
 IOX detects and diagnoses I/O problems on the disk and tape units
 of your hardware configuration.  Using the IOX command language, you
 can execute, control, and monitor I/O exercises on device units that
 you specify for exercising.  See the RSX-11M/M-PLUS System Management
 Guide for more specific information.

 You can make decisions about three aspects of testing and use the 
 appropriate command to implement those decisions.

 You must perform these steps:

  1.  Invoke IOX.

  2.  Determine which devices you want to test and include them in your
      test configuration.

  3.  Determine the kind of exercise to run on each unit in your test
      configuration

  4.  Set exercise parameters to affect how IOX tests the units you
      want to exercise.

  5.  Begin the exercise and possibly interrupt the exercise to change
      steps 2, 3, and 4.

  6.  Monitor the activity and error reports that IOX generates during
      an exercise.

  7.  Exit IOX or repeat this process beginning at step 2, 3, 4, or 5
      as appropriate.

 INVOKING IOX

 Use either >IOX if IOX is installed, or RUN $IOX if it is not.

 The prompt is TTxx>  where xx is your terminal number.  You can then
 enter IOX commands.

 See also HELP IOX MODES and HELP IOX COMMANDS.
2 MODES
 IOX HAS THREE OPERATING MODES:

 Command mode is the mode IOX is in when you receive the prompt.  You
              set parameters, select devices for testing, and
              initiate tasks to be executed in Command Mode.  In
              this mode, the RETURN key gives you the prompt again,
              the CTRL/C key exits to MCR for one command line.

 Execution mode is the mode entered with the START command that you
                entered in command mode.  In this mode, exercises
                start on the selected devices, tasks initiated with
                the EXECUTE command start executing, the IOX clock is
                turned on, and activity and error reporting begins.
                If you have specifed that CONTROL_C is enabled, when
                you press CTRL/C in execution mode, IOX enters
                interactive mode.

 Interactive mode is entered only if you have enabled CONTROL_C.
                If enabled, pressing CTRL/C in execution mode causes
                IOX to enter interactive mode.  In interactive mode,
                CTRL/C and RETURN have the same function as in command
                mode.

                The following commands are not valid in interactive
                mode:
                BUFFERSIZE, PATTERN, RUNTIME, START, RESTART

                The following commands are valid only in interactive
                mode:
                ABORT, PRINTSUMMARY, PROCEED, SPY

 See also HELP IOX COMMANDS.
2 COMMANDS
 IOX HAS FOUR CATEGORIES OF COMMANDS:

 Function commands that select devices for testing and deselect devices
                   from testing, and initiate tasks to run in parallel
                   with IOX.

                   To list function commands, enter HELP IOX FUNCTION.

 Control commands that start and stop IOX processing, switch IOX modes
                   of operation, and exit from IOX.

                   To list control commands, enter HELP IOX CONTROL.

 Display commands that display current default parameters, get help
                   text for IOX commands, and display status and
                   activity reports during an I/O exercise.

                   To list display commands, enter HELP IOX DISPLAY.

 Parameter commands that set default parameters that affect how IOX
                   tests the devices you select for testing.

                   To list parameter commands, enter HELP IOX PARAMETER.

 See also HELP IOX MODES.
2 FUNCTION

 The function commands are:
 DESELECT
 EXECUTE
 FILES11
 SELECT
 VERIFY

 For information about each command, enter HELP IOX commandname
2 CONTROL

 The control commands are:
 ABORT
 CTRL/C
 EXIT
 PROCEED
 RESTART
 START

 For information about each command, enter HELP IOX commandname
2 DISPLAY

 The display commands are:
 BADBLOCKS
 CONFIGURE
 DENSITY
 HELP
 PARAMETERLIST
 PATTERN
 PRINTSUMMARY
 RANGE
 SPY

 For information about each command, enter HELP IOX commandname
2 PARAMETER

 The parameter commands are:
 BADBLOCKS     RANDOM
 BUFFERSIZE    RANGE
 COMPAREDATA   RECORDS
 CONFIGURE     REPORTERRORS
 CONTROL_C     RETRIES
 DENSITY       RUNTIME
 ERRORLIMIT    SUMMARYTIME
 INTERLEAVE    TEMPORARYFILE
 LOGFILE       VOLUMECHECK
 PATTERN       WAIT
               WRITECHECK

 For information about each command, enter HELP IOX commandname
3 ABORT

 ABORT is an IOX control command.  The three forms of ABORT are:

 ABORT
      Terminates an I/O exercise and tasks initiated by EXECUTE.
      This form of ABORT is valid only in interactive mode.

 ABORT /ALL
      Interactive mode -- Terminates all tasks initiated by EXECUTE
           and removes them from the list of tasks to be executed.
      Command mode -- Removes all tasks from the list of tasks to be
           executed.

 ABORT taskname
      Interactive mode -- Terminates a task initiated by EXECUTE
           and removes it from the list of tasks to be executed.
      Command mode -- Removes the task from the list of tasks to be
           executed.

 You cannot use ABORT to terminate a task that has attached your terminal.
3 BADBLOCKS

 BADBLOCKS is both a parameter and display command.  Used as a parameter
 command, you can enter those blocks that you do not want IOX to test.
 These blocks would be the ones that were found by the BAD utility.
 BADBLOCKS used as a display command, displays those blocks that
 you have entered in the IOX badblocks list by using BADBLOCKS as
 a parameter command.  IOX does not find the badblocks for you as
 the BAD utility does.

 Use BADBLOCKS as a parameter command by specifying the device and
 the blocks to be entered on the list.  For example:

      BADBLOCKS DM1: 3

           enters block 3 of device DM1 on the badblocks list.

      BADBLOCKS DM1: 3,4,5,11,12,13,99,151

           enters blocks 3 to 5, 11 to 13, 99, and 151 on the badblocks
           list

      BADBLOCKS DM1: 3:5,11:4,99,150:10

           enters 5 blocks starting at 3, 4 blocks starting at 11,
           block 99, and 10 blocks starting at 150.  In other words,
           blocks 3 to 8, 11 to 14, 99, and 150 to 159.

 Use BADBLOCKS as a display command to show the badblock list.
 You do this be entering only the device.
 For example, after the last command above, if you entered

           BADBLOCKS DM1:

 IOX would display:

           000003:005
           000011:004
           000099:001
           000150:010
3 BUFFERSIZE
 BU[FFERSIZE] buffersize 

 Use BUFFERSIZE, a device-dependent paramenter command, to determine
 the amount of data transfered in read/write requests.  Use this
 command for nonfile-structured disks, magnetic tapes, and cassettes.
 BUFFERSIZE rounds the nember up to the next four-byte boundary.

 If you use the RANDOM data pattern, do not specify more than 3400(10)
 bytes.

 FILES-11 testing is fixed, using a 512.-byte buffer.
 DECtape testing is fixed, using a 1024.-byte buffer.

 Use BUFFERSIZE only in command mode, and only when units are not
 currently selected.  Use BUFFERSIZE before selecting devices.
 You can use BUFFERSIZE in the SELECT and VERIFY command lines to
 override the default buffersize for the selected device as long
 as you set the buffersize smaller than the default.

 The initial default is 1024(10) bytes.
3COMPAREDATA
 COM[PAREDATA] Y[ES]/N[O]

 COMPAREDATA, a parameter command, compares data read from to the data
 written to a device.  COMPAREDATA YES enables the compare
 and COMPAREDATA NO disables the compare.  If the data does not
 match, IOX generates an error report.

 Used within the command lines of FILES11 and SELECT, COMPAREDATA
 overrides the current setting for the device being tested.

 The initial default is COMPAREDATA YES.
3 CONFIGURE
 CONF[IGURE] [dduu:[=type]]

 CONFIGURE is both a parameter and a display command.  As a parameter
 command, CONFIGURE adds devices to be tested.  As a display command,
 it shows the current configuration of devices to be tested.

 Devices must be configured before selection for testing.  Devices
 remain configured until you issue the RESTART IOX command.

 CONFIGURE used alone displays the current configuration, as:

      IOX>CONFIGURE

      Disks:

      DB0  DD0  DF0  DK0  DL0  ...

      Tapes:

      CT0  DT0  MM0  ...

 To add devices to a test configuration, use:

      IOX>CONFIGURE DK1:  DB1:  YY:  MM5:  MQ1:=TAPE

 Separate unit specifications with spaces or tabs.

 Defaults:

 Each supported unit is assumed  to be unit "0".
 Any device assignable with MCR ASN can be configured.
 If a unit of a device type is configured as a disk, all such devices
 are configured as disks.  The same is true for tapes.  IOX does not
 allow disks to be configured as tapes or tapes as disks.

 In the above example, YY: is configured as YY0: and as a disk,
 both of which are defaults because YY: was not previously configured.
 MQ: would default to a disk because it was not previously configured,
 but TAPE is specified to inform IOX of its true nature.
3 CNTRL/C
#CTRL/C
3 CTRL/C

 CTRL/C, a control command in IOX, has different actions depending on
 the mode in which it is executed. See also HELP IOX CONTROL_C.

 In command mode:
      CTRL/C generates an MCR prompt "MCR>" allowing you to enter one
      MCR command line.
 In interactive mode:
      CTRL/C generates an MCR prompt "MCR>" allowing you to enter one
      MCR command line.
 In execution mode with the CONTROL_C YES command previously entered,
      CTRL/C causes IOX to leave execution mode and enter interactive
      mode.
 In execution mode with the CONTROL_C NO command previously entered,
      CTRL/C generates the MCR prompt "MCR>" to allow you to enter
      one MCR command line.
3 CONTROL_C
 CONTROL_C Y[ES]/N[O]

 CONTROL_C, a parameter command, enables or disables the use of
 CTRL/C to interrupt an I/O exercise.  The mode of operation determines
 the effect of CONTROL_C.  See also HELP IOX CTRL/C.

 Command mode:
      CONTROL_C has no effect on CTRL/C in command mode.  CTRL/C
      allows you to enter one MCR command line.

 Execution mode:
      CONTROL_C NO -- CTRL/C gives control to MCR and you get an
      MCR prompt ">" with the RETURN key and "MCR>" with CTRL/C.
      You cannot interrupt IOX to enter IOX commands.  You can
      abort IOX with the MCR ABORT command.
      CONTROL_C YES -- CTRL/C is the only valid input.  It gives
      the IOX prompt and IOX enters interactive mode.

 Interactive mode:
      CONTROL_C YES -- IOX can enter interactive mode only if
      CONTROL_C is enabled.  In this mode, most IOX commands are
      valid.  RETURN and CTRL/C have the same effect as in command
      mode.

 The initial default is CONTROL_C YES.
3 DENSITY
 DEN[SITY] dduu: [n]

 DENSITY is both a parameter and a display command valid only for
 magnetic tapes.  The device is dduu and the density is n.  Enter n
 as a decimal number (200, 556, 800, 1600) without a decimal point.

 If n is not present, DENSITY displays the current density and the
 characteristic word of the device.  The default characteristic word
 is 004004(8).  The density may appear in the characteristic word
 for some devices.
3 DESELECT
 DES[ELECT] ddnn:

 DESELECT, a function command, deselects devices that were selected
 with SELECT, VERIFY, or FILES11 commands.

 Issued in interactive mode, DESELECT terminates testing on the device
 and removes it from the list of devices to be tested.

 Issued in command mode, DESELECT removes the device from the list of
 devices to be tested.

 DESELECT does not remove a device from the test configuration.
3 ERRORLIMIT
 ER[RORLIMIT] n

 ERRORLIMIT, a parameter command, sets the maximum number of errors
 that IOX will tolerate between interval reports before deselecting
 a device.  The SUMMARYTIME command determines the interval in
 minutes between reports.  If errors during that interval exceed
 the limit set by ERRORLIMIT in that interval, IOX deselects
 the device from testing.

 The initial default is 10 errors.
3 EXECUTE
 EXE[CUTE] taskname commandstring

 EXECUTE, a function command, directs a command to the operating
 system for execution.  The task to be run must be installed and the
 system must support task spawning.

 The rules for entering the taskname commandstring follow the same
 rules as the SPWN$ directive described in the RSX-11M/M-PLUS
 Executive Reference Manual.

 In interactive mode:
      Testing is in progress.  The task named runs immediately.

 In commmand mode:
      No testing in progress.  IOX queues the task for execution.
      The task executes when you use the START command.  The task
      runs in parallel with I/O exercises.

 Example:
      IOX>EXE ...BAD #DL0:/LI

      Some tasks need a space between the command and the
      command string.  Some tasks, such as PIP, do not.
      The pound sign forces a space.

 To remove a task from the list of tasks to be executed and terminate
 task execution, use the IOX ABORT command.
3 EXIT
 EXI[T]

 EXIT, a control command, terminates IOX processing.
3 FILES11
 F[ILES11] dduu: [command=qualifier] ...

 FILES11, a function command, selects a Files-11 disk for exercising.
 FILES11 protects the contents and structure of the disk.  You must
 configure the disk first.

 The following parameter commands override default parameters:

 COMPAREDATA
 ERRORLIMIT
 INTERLEAVE
 RANDOM
 TEMPORARYFILE

 Eample:
      IOX>FILES11 DB0: COMPAREDATA=YES RANDOM=NO TEMPORARYFILE=600

 The example command line selects DB0: for exercising.  IOX compares
 the data read with that written, uses sequential access, and opens
 a 600 block temporary file.

 Once selected, the device's parameters are fixed until you deselect
 the device.  If you enter only the device in the command line, the
 parameters are those currently in effect.

 Issuing FILES11 in interactive mode causes immediate testing of the
 device.  Issuing FILES11 in command mode, IOX puts the device on the
 list of device to be tested when you issue the START command.
3 HELP
 HELP

 HELP is a display command that you can enter to display a brief
 description of IOX and its commands at your terminal.
3 INTERLEAVE
 I[NTERLEAVE] number

 INTERLEAVE, a parameter command, sets the number of blocks to
 be skipped before IOX writes the next buffer of data.
 INTERLEAVE works only if you set RANDOM NO.
 You can use INTERLEAVE within the FILES11, SELECT, and VERIFY
 command to override the current default.
 The initial default is RANDOM YES.
 The initial default for skipping is 4 blocks.
3 LOGFILE
 L[OGFILE] Y[ES]/N[O]

 LOGFILE, a parameter command, directs activity and error
 reports to your terminal or to a log file in your default
 disk area.

 NO
       Directs activity and error reports to your terminal.

 YES
       Directs activity and error reports to the log file.

 Summary reports, generated by the PRINTSUMMARY command, always
 appear at your terminal.  IOX appends to the log file every time
 you specify LOGFILE in an IOX session.  The file is named:

      yyyyyy.LOG

 where yyyyyy is IOX, another task running IOX, or your terminal;
 for example, TT10.LOG.
3 PARAMETERLIST
 PAR[AMETERLIST]

 PARAMETERLIST displays the current default parameters and IOX
 buffer space statistics, and may display the list of
 tasks initiated by EXECUTE, and devices selected for testing
 with FILES11, SELECT, and VERIFY.  What is displayed depends
 on which commands you have previously entered.

 CTRL/O suppresses the output of PARAMETERLIST in command mode.
3 PATTERN
 PAT[TERN] [patternnumber]

 PATTERN, a parameter command and display command, selects and
 displays the pattern IOX uses for read/write testing.  PATTERN
 shows the thirteen patterns and show the current default pattern
 with an asterisk (*).  For example:

      IOX>PATTERN
           0 = Random Data *
           1 = 000000,000000
           2 = 177777,177777
           3 = 125252,052525
           4 = 165555,133333
           5 = 163126,163126
           6 = 055555,155555
           7 = 022222,122222
           8 = 111111,111111
           9 = 007417,007417
          10 = 021042,021042
          11 = 104210,104210
          12 = 052652,052652

 To change the pattern, use the number of the pattern you want in the
 PATTERN command.  You must be in command mode to change the pattern.
 Do not exceed 3400. bytes of buffersize if using the random data
 pattern.
3 PRINTSUMMARY
 PRI[NTSUMMARY]

 PRINTSUMMARY, a display command for use in interactive mode, causes
 IOX to generate a summary report to your terminal.  It shows the IOX
 activity from the last interval report to the time you entered
 PRINTSUMMARY.
3 PROCEED
 PRO[CEED]

 PROCEED, a control command entered in interactive mode, causes IOX to
 exit interactive mode and enter execution mode.  If no exercises are
 in progress and no tasks are scheduled, IOX terminates.

 If activity is occurring, IOX resumes display of activity and error
 reports to your terminal if you have set LOGFILE NO.

 Use the proceed command if you want IOX to terminate an exercise
 as soon as activity terminates or if you want to resume activity
 and error report display at your terminal with LOGFILE disabled.
3 RANDOM
 RAND[OM] Y[ES]/N[O]

 RANDOM, a parameter command, applies to disk testing and controls
 either random or sequential block selection for testing.

 RANDOM YES causes IOX to select blocks for testing randomly.
 RANDOM NO causes IOX to select blocks for testing sequentially.
 The number entered in the INTERLEAVE command causes IOX to skip
 the number of blocks specified between tested blocks.

 Use RANDOM in FILES11, SELECT, and VERIFY to override the current
 default.  The initial default is RANDOM YES.
3 RANGE
 RANG[E] dduu: [minimum:maximum]

 RANGE, both a display and parameter command, applies to disks
 selected for nonfile-structured testing with SELECT or VERIFY.
 RANGE sets a range of blocks to be tested by specifying the minimum
 and maximum block numbers of the range.  RANGE used without numbers
 displays the block numbers.  The device must have been selected
 previously.

 The default is from zero to the maximum available block on the disk.
3 RECORDS
 REC[ORDS] recordcount

 RECORDS, a parameter command, specifies the number of records
 on a magtape or cassette to be exercised.  Entering a zero causes
 IOX to test the tape until end-of-tape.  You can use RECORDS in the
 SELECT command.  The initial default is 1024. records.
3 REPORTERRORS
 REP[ORTERRORS] Y[ES]/N[O]

 REPORTERRORS, a parameter command, enables or disables IOX error reports.
 IOX directs reports to your terminal with these exceptions:

      o  Error reports never interrupt activity reports

      o  With LOGFILE enabled, IOX enters error reports in the log
         file instead of displaying them at the terminal

      o  IOX does not pring error reports in interactive mode

 The default is REPORTERRORS YES.
3 RESTART
 RES[TART]

 RESTART, a control command valid only in command mode, enables
 you to restart IOX without first exiting from it.

 RESTART:
      o  Deselects devices that are selected for testing

      o  Resets all parameters to their initial defaults

      o  Removes all tasks from the list of tasks to be executed

      o  Unconfigures all devices added to the configuration
3 RETRIES
 RET[RIES] Y[ES]/N[O]

 RETRIES, a parameter command, applies to the testing of magnetic tapes
 and nonfile-structured disks. RETRIES YES allows the device driver to
 use its standard error recovery techniques.  RETRIES NO dissallows the
 driver from doing this.  You can use this command within SELECT and
 VERIFY.  The default is RETRIES YES.
3 RUNTIME
 RUN[TIME] minutes

 RUNTIME, a parameter command valid in command mode, specifies the
 length of time that IOX is to test the selected devices.  If you
 use 0 minutes, IOX tests the devices until you abort the exercise.
 The default is five minutes.
3 SELECT
 SE[LECT] dduu: [command=qualifier] ...

 SELECT, a function command, selects a device with an nonfile-structured 
 volume mounted for an I/O exercise that destroys the contents and structure 
 of thevolume.  The device must first be configured. You may use the following 
 commands within the SELECT command to determine the testing parameters that 
 you want:

     NFS DISKS       CASSETTES        DECTAPES       MAGTAPES

     BUFFERSIZE      BUFFERSIZE       COMPAREDATA    BUFFERSIZE
     COMPAREDATA     COMPAREDATA      ERRORLIMIT     ERRORLIMIT
     ERRORLIMIT      ERRORLIMIT                      DENSITY
     INTERLEAVE      RECORDS                         RECORDS
     RANDOM                                          RETRIES
     RANGE
     RETRIES
     VOLUMECHECK
     WRITECHECK

 Once you have selected the device, the default parameters are fixed
 and you must first deselect the device to reset the parameters.
 In interactive mode, SELECT causes IOX to start testing the device
 immediately.  In command mode, IOX puts the specified device on the
 list of devices to be exercised but the exercise begins with the START
 command.  If you use no commands in the SELECT command line, the current
 parameters are used.
3 SPY
 SP[Y] [dduu:]

 SPY, a display command valid in interactive mode, display the status
 of devices being tested.  Without an argument, the status of all
 devices is shown.  The display shows:

      o  Device being exercised

      o  Type of testing being performed

      o  Virtual block number being tested, or, for nonfile-structured 
         devices, the logical block number

      o  I/O request status:  AST queued, in progress, or idle.

      o  Type of I/O: read or write

 The output is always to the terminal.
3 START
 ST[ART]

 START, a control command valid in command mode, causes IOX to exit
 command mode and enter execution mode.  After configuring and
 selecting devices, you start the exercise with START.  START turns on
 the IOX clock, begins activity and error reports,
 and executes tasks queued by EXECUTE.
3 SUMMARYTIME
 SU[MMARYTIME] minutes

 SUMMARYTIME, a parameter command, specifies how often in minutes IOX
 outputs interval reports.  Reports are suppressed by using 0 minutes.
 The default is one minute.
3 TEMPORARYFILE
 T[EMPORARYFILE] filesize

 TEMPORARYFILE, a parameter command, is for Files-11 disk testing
 with the FILES11 command.  FILES11 protects disks by writing
 a temporary file that IOX deletes at the end of the exercise.
 Specify filesize in blocks.  Use the TEMPORARYFILE command in FILES11
 to change the number of blocks for the disk being selected.
 The default is 500 blocks.
3 VERIFY
 VE[RIFY] dduu: [command=qualifier] ...

 VERIFY, a function command, selects a mounted nonfile-structured disk
 for exercise.  VERIFY reads only and does not destroy the disk's contents.
 VERIFY accepts the following parameter commands to override defaults:

 BUFFERSIZE, ERRORLIMIT, INTERLEAVE, RANDOM, RANGE, RETRIES

 Once selecting the device, you must deselect it to change parameters.
 VERIFY issued in interactive mode begins exercising immediately.
 Issued in command mode, it includes the device in the list of devices
 to be exercised and you must issue START to begin the exercise.
 Without parameter commands, VERIFY uses the current parameters in
 effect.
3 VOLUMECHECK
 VO[LUMECHECK] Y[ES]/N[O]

 VOLUMECHECK, a parameter command, applies to nonfile-structured disk testing 
 and is used with SELECT.  VOLUMECHECK enables or disables nonfile-structured
 volume checking for a home-block and Files-11 structure.  Using YES
 disallows selecting a volume with a Files-11 structure.  Using NO
 allows selecting the disk without warning that the disk contents
 will be destroyed.  Use VOLUMECHECK YES unless you intentionally
 want to write all over the disk.
 The default is VOLUMECHECK YES.
3 WAIT
 WA[IT] Y[ES]/N[O]

 WAIT, a parameter command, can cause IOX to wait for an event flag
 (I/O completion) while an exercise is in progress.  The Executive
 may execute another task during this time.  With NO, IOX goes into
 an idle loop during I/O.  WAIT NO can monopolize the system.
 WAIT NO has no effect on tasks initiated with EXECUTE.
 The default is WAIT YES.
3 WRITECHECK
 WR[ITECHECK] Y[ES]/N[O]

 WRITECHECK, a parameter command, applies to testing nonfile-structured
 disks and it is used with SELECT.  WRITECHECK determines whether
 drivers perform writechecks to nonfile-structured disks.
 The default is WRITECHECK NO.
